@echo off
::345678901234567890123456789012345678901234567890123456789012345678901234567890
::
:: usage: refresh-any-comment.bat pluginDir tempDir catalogPath synclrdataPath
::
:: Causes LR to exit gracefully. Then runs the SQLite scripts in "pluginDir"
:: to extract the comments and likes data from the Lightroom catalog
:: "catalogPath" and LR Mobile sync data "synclrdataPath", putting the results
:: into "tempDir".  Finally, restarts Lightroom to open "catalogPath".
::
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

set pluginDir=%1
set tempDir=%2
set catalogPath=%3
set synclrdataPath=%4

pushd %pluginDir%

wmic process where "name='lightroom.exe'" get ExecutablePath /FORMAT:table ^
    | awk "NR==2 {print $0}" > %tempDir%/lrpath.txt
set /p lrPath=<%tempDir%/lrpath.txt

taskkill /im lightroom.exe /t 2> NUL > NUL
:loop1
    tasklist /fi "imagename eq lightroom.exe" | find "INFO: No tasks" > NUL
    if not errorlevel 1 goto loop1exit
    cscript sleep250.vbs > NULL
    goto loop1
:loop1exit

sqlite3 %catalogPath% < publish-comments.sql ^
	> %tempDir%/publish-comments.csv 
    if errorlevel 1 echo sqlite3 failed "(%errorlevel%)"
sqlite3 %catalogPath% < publish-likes.sql ^
	> %tempDir%/publish-likes.csv 
    if errorlevel 1 echo sqlite3 failed "(%errorlevel%)"

sqlite3 %catalogPath% < mobile-comments.cat.sql ^
	> %tempDir%/mobile-comments.cat.csv 
    if errorlevel 1 echo sqlite3 failed "(%errorlevel%)"

awk -v synclrdataPath=%synclrdataPath% -f mobile-docstores.awk ^
	%tempDir%/mobile-comments.cat.csv > %tempDir%/mobile-comments.doc.sql 
    if errorlevel 1 echo awk failed "(%errorlevel%)"
sqlite3 < %tempDir%/mobile-comments.doc.sql ^
    > "%tempDir%"/mobile-comments.doc.csv 
    if errorlevel 1 echo sqlite3 failed "(%errorlevel%)"

    :: Go back to the former working directory, since "start" can't 
    :: handle network shares as the working directory!
popd
start "%lrPath%" %catalogPath% 