#!/bin/sh
#2345678901234567890123456789012345678901234567890123456789012345678901234567890
#
# usage: refresh-any-comment.sh tempDir catalogPath synclrdataPath
#
# Should be run cd'ed to the plugin directory. Causes LR to exit gracefully.
# Then runs the SQLite scripts in "pluginDir" to extract the comments and
# likes data from the Lightroom catalog "catalogPath" and LR Mobile sync data
# "synclrdataPath", putting the results into "tempDir".  Finally, restarts
# Lightroom to open "catalogPath".
#
################################################################################

tempDir=$1
catalogPath=$2
synclrdataPath=$3

i=0
while true; do
    ## echo "refresh-any-comment.sh" $i >> /tmp/anycomment.log
	osascript -e 'tell application "Lightroom" to quit' >& /dev/null
	ps axc -o comm | grep Lightroom > /dev/null
	if (($? != 0)); then break; fi 
    i=$((i + 1))
    if ((i >= 20)); then 
        echo "Failed to terminate Lightroom"
        exit 1
        fi
    sleep 0.25
	done

sqlite3 "$catalogPath" < publish-comments.sql \
	> "$tempDir"/publish-comments.csv \
    || echo sqlite3 failed "($?)"
sqlite3 "$catalogPath" < publish-likes.sql \
	> "$tempDir"/publish-likes.csv \
    || echo sqlite3 failed "($?)"

sqlite3 "$catalogPath" < mobile-comments.cat.sql \
	> "$tempDir"/mobile-comments.cat.csv \
    || echo sqlite3 failed "($?)"

awk -v "synclrdataPath=$synclrdataPath" -f mobile-docstores.awk \
	"$tempDir"/mobile-comments.cat.csv > "$tempDir"/mobile-comments.doc.sql \
    || echo awk failed "($?)"
sqlite3 < "$tempDir"/mobile-comments.doc.sql \
    > "$tempDir"/mobile-comments.doc.csv \
    || echo sqlite3 failed  "($?)"

open "$catalogPath" \
    || exit $?